# lines starting with '#' are comments

#############################
#basic statistics in R and igraph
#############################

## send egonet from visone to r

##compute a centrality in igraph 
pr <- page.rank(egonet)
V(egonet)$pagerank <- pr$vector
# load egonet into visone

## generate a random graph in igraph
tree.20 <- graph.tree(20)
# load it into visone

## see the distribution of attributes
V(egonet)$Afrm # these are coded as character not factor 
from <-as.factor(V(egonet)$Afrm)
summary(from)
city <- as.factor(V(egonet)$Acit)
rel.type <- as.factor(V(egonet)$Arel)
summary(rel.type)
# cross-tabulation
rel.type.by.city <- tapply(rel.type, city, summary)

#############################
# ERGModeling
#############################

## install some packages from statnet
install.packages("network", lib = "C:/juergen/software/visone/R", repos = "http://cran.rakanu.com")
library(network, lib.loc = "C:/juergen/software/visone/R")
install.packages("sna", lib = "C:/juergen/software/visone/R", repos = "http://cran.rakanu.com")
library(sna, lib.loc = "C:/juergen/software/visone/R")
install.packages("ergm", lib = "C:/juergen/software/visone/R", repos = "http://cran.rakanu.com")
library(ergm, lib.loc = "C:/juergen/software/visone/R")

##convert egonet to the network package
adj <- get.adjacency(egonet)
net <- as.network(adj, directed=FALSE)
set.vertex.attribute(net,"From", V(egonet)$Afrm)
set.vertex.attribute(net,"City", V(egonet)$Acit)
summary(get.vertex.attribute(net,"From"))
summary(get.vertex.attribute(net,"City"))
#create an igraph from an adjacency matrix: graph.adjacency(adj, mode="undirected")

## summary methods in ergm
summary(net ~ idegree(0:44))

##expected number of triangles
p <- 190/choose(45,2)# edge probability
triag.expected <- p^3*choose(45,3)
triag.expected
# observed number of triangles
summary(net ~ triangle)

##examples of ERGMs
model <- ergm(net ~ edges + nodematch("From"))
model <- ergm(net ~ edges + triangle, constraints=~edges)
model <- ergm(net ~ edges + gwesp(0.5), MCMCsamplesize=100000)
summary(model)
model <- ergm(net ~ edges + nodematch("From") + nodematch("City") + triangle, constraints=~edges)
model <- ergm(net ~ edges + nodematch("From") + nodematch("City") + kstar(2) + triangle, constraints=~edges)
model <- ergm(net ~ edges + nodematch("From") + nodematch("City") + gwesp(0.1, fixed=TRUE))
# in gwXXX: first argument alpha starting from zero moving to infty; closer to zero is less likely to be degenerate


